#ifndef _CMDS_H_
#define _CMDS_H_

//inclusions////////////////////////////////////////////////////////////////////
#include "vga.h"
#include "lcd.h"
#include "sys/alt_irq.h"
#include "ethernet.h"
#include "keyboard.h"
#include "log.h"
#include "filter.h"

//variables/////////////////////////////////////////////////////////////////////
extern unsigned char ether_addr[6];
extern unsigned short int verbosity;
extern unsigned short int logging;
extern unsigned short int status_bar;
extern unsigned short int capturing;
extern struct filterRule filter_Rules[5];
extern int filter_On;

//function declarations/////////////////////////////////////////////////////////

//commands that display crap
void splash(unsigned char* data);      //print a splash screen
void sysinfo(unsigned char* data);     //print system info
void praise(unsigned char* data);      //show L33T reviews of the e-sniff system
void help(unsigned char* data);        //show help
void homer(unsigned char* data);       //show homer

//commands that affect capture
void setCapture(unsigned char* data);  //start/stop capture

//commands that affect the filter
void setFilter(unsigned char* data);   //set the filter(s)

//commands that affect verbosity
void setVerbosity(unsigned char* data); //set how much output the system generates

//commands that affect logging
void setLog(unsigned char* data);       //to log or not to log?

//commands that load/save system config
void config_cmd(unsigned char* data);   //save or load config

//commands that change the appearance of the status bar
//TODO: this
void setStatus(unsigned char* data);    //can show cpu meter, command output, or stats

//command error message
void cmdErrMsg(unsigned char* data);    //I didn't recognize the command, try help

#endif //_CMDS_H_
