#ifndef _FILTER_H_
#define _FILTER_H_

//inclusions////////////////////////////////////////////////////////////////////
#include "vga.h"

//definitions///////////////////////////////////////////////////////////////////

//responses from filter functions
#define FILTER_PASS 0
#define FILTER_DROP 1
#define FILTER_INACTIVE 2
#define FILTER_ACTIVE 3

//values for active field
#define FILTER_RULE_ACTIVE 0x1
#define FILTER_RULE_INACTIVE 0xFE
#define FILTER_SRCMAC_ACTIVE 0x2
#define FILTER_DESTMAC_ACTIVE 0x4
#define FILTER_SRCIP_ACTIVE 0x8
#define FILTER_DESTIP_ACTIVE 0x10
#define FILTER_SPORT_ACTIVE 0x20
#define FILTER_DPORT_ACTIVE 0x40
#define FILTER_PROTO_ACTIVE 0x80

//values for protocol field
#define FILTER_PROTO_ANY 0
#define FILTER_PROTO_ARP 1
#define FILTER_PROTO_IP 2
#define FILTER_PROTO_UDP 3
#define FILTER_PROTO_TCP 4

//filter rule structure/////////////////////////////////////////////////////////
struct filterRule{
  int active;                     //flags to show which rules are active
  unsigned char src_mac[6];       //source MAC address
  unsigned char dest_mac[6];      //destination MAC address
  unsigned char src_ip[4];        //Source IP addr
  unsigned char src_netmask[4];   //source IP netmask
  unsigned char dest_ip[4];       //dest ip addr
  unsigned char dest_netmask[4];  //dest ip netmask
  unsigned char src_port[2];      //source port
  unsigned char dest_port[2];     //dest port
  unsigned int protocol;          //protocol
}filterRule;

//function prototypes///////////////////////////////////////////////////////////
int ApplyFilters(unsigned char * data, unsigned int * len);
int ApplyFilterRule(unsigned char *data, unsigned int * len, unsigned int ruleNum);

#endif //_FILTER_H_
