#ifndef _LCD_H_
#define _LCD_H_

#include <io.h>
#include <unistd.h>
#include "system.h"

//definitions for LCD
#define LCD_RESULT  unsigned short int
#define LCD_SUCCESS       0x0     
#define LCD_FAIL          0x1        
#define LCD_COMMAND(data) IOWR(OPTREX_LCD_BASE, 0, data)          //issue cmd
#define LCD_DATA(data)    IOWR(OPTREX_LCD_BASE, 2, data)          //write data
#define LCD_BUSY          IORD(OPTREX_LCD_BASE, 1) & 0x00000080u  //lcd busy?
#define LCD_CLEAR()       IOWR(OPTREX_LCD_BASE, 0, 0x01)          //clear screen
#define LCD_NEWLINE()     IOWR(OPTREX_LCD_BASE, 0, 0xC0)          //new line

inline LCD_RESULT lcd_init(void);
inline void lcd_newline(void);
inline void lcd_clear(void);
void lcd_char(char c);
void lcd_string(const char* ptr, int len);

#endif //_LCD_H_
